// This file has been generated by Py++.

// ************************************************************************** //
//
//  BornAgain: simulate and fit scattering at grazing incidence
//
//! @file      Automatically generated boost::python code for BornAgain Python bindings
//! @brief     Automatically generated boost::python code for BornAgain Python bindings
//!
//! @homepage  http://bornagainproject.org
//! @license   GNU General Public License v3 or higher (see COPYING)
//! @copyright Forschungszentrum Juelich GmbH 2015
//! @authors   Scientific Computing Group at MLZ Garching
//! @authors   C. Durniak, M. Ganeva, G. Pospelov, W. Van Herck, J. Wuttke
//
// ************************************************************************** //

#include "Macros.h"
GCC_DIAG_OFF(unused-parameter)
GCC_DIAG_OFF(missing-field-initializers)
#include "boost/python.hpp"
GCC_DIAG_ON(unused-parameter)
GCC_DIAG_ON(missing-field-initializers)
#include "PythonCoreList.h"
#include "DistributionGaussian.pypp.h"

namespace bp = boost::python;

struct DistributionGaussian_wrapper : DistributionGaussian, bp::wrapper< DistributionGaussian > {

    DistributionGaussian_wrapper(DistributionGaussian const & arg )
    : DistributionGaussian( arg )
      , bp::wrapper< DistributionGaussian >(){
        // copy constructor
        m_pyobj = 0;
    }

    DistributionGaussian_wrapper( )
    : DistributionGaussian( )
      , bp::wrapper< DistributionGaussian >(){
        // null constructor
    m_pyobj = 0;
    }

    DistributionGaussian_wrapper(double mean, double std_dev )
    : DistributionGaussian( mean, std_dev )
      , bp::wrapper< DistributionGaussian >(){
        // constructor
    m_pyobj = 0;
    }

    virtual ::DistributionGaussian * clone(  ) const  {
        if( bp::override func_clone = this->get_override( "clone" ) )
            return func_clone(  );
        else{
            return this->DistributionGaussian::clone(  );
        }
    }
    
    ::DistributionGaussian * default_clone(  ) const  {
        return DistributionGaussian::clone( );
    }

    virtual ::std::vector< double > generateValueList( ::std::size_t nbr_samples, double sigma_factor, ::AttLimits const & limits=::AttLimits( ) ) const  {
        if( bp::override func_generateValueList = this->get_override( "generateValueList" ) )
            return func_generateValueList( nbr_samples, sigma_factor, boost::ref(limits) );
        else{
            return this->DistributionGaussian::generateValueList( nbr_samples, sigma_factor, boost::ref(limits) );
        }
    }
    
    ::std::vector< double > default_generateValueList( ::std::size_t nbr_samples, double sigma_factor, ::AttLimits const & limits=::AttLimits( ) ) const  {
        return DistributionGaussian::generateValueList( nbr_samples, sigma_factor, boost::ref(limits) );
    }

    virtual double getMean(  ) const  {
        if( bp::override func_getMean = this->get_override( "getMean" ) )
            return func_getMean(  );
        else{
            return this->DistributionGaussian::getMean(  );
        }
    }
    
    double default_getMean(  ) const  {
        return DistributionGaussian::getMean( );
    }

    virtual double probabilityDensity( double x ) const  {
        if( bp::override func_probabilityDensity = this->get_override( "probabilityDensity" ) )
            return func_probabilityDensity( x );
        else{
            return this->DistributionGaussian::probabilityDensity( x );
        }
    }
    
    double default_probabilityDensity( double x ) const  {
        return DistributionGaussian::probabilityDensity( x );
    }

    virtual ::std::vector< double > generateValues( ::std::size_t nbr_samples, double xmin, double xmax ) const  {
        if( bp::override func_generateValues = this->get_override( "generateValues" ) )
            return func_generateValues( nbr_samples, xmin, xmax );
        else{
            return this->IDistribution1D::generateValues( nbr_samples, xmin, xmax );
        }
    }
    
    ::std::vector< double > default_generateValues( ::std::size_t nbr_samples, double xmin, double xmax ) const  {
        return IDistribution1D::generateValues( nbr_samples, xmin, xmax );
    }

    PyObject* m_pyobj;

};

void register_DistributionGaussian_class(){

    { //::DistributionGaussian
        typedef bp::class_< DistributionGaussian_wrapper, bp::bases< IDistribution1D >, std::auto_ptr< DistributionGaussian_wrapper > > DistributionGaussian_exposer_t;
        DistributionGaussian_exposer_t DistributionGaussian_exposer = DistributionGaussian_exposer_t( "DistributionGaussian", "Gaussian distribution with standard deviation std_de.", bp::init< >() );
        bp::scope DistributionGaussian_scope( DistributionGaussian_exposer );
        DistributionGaussian_exposer.def( bp::init< double, double >(( bp::arg("mean"), bp::arg("std_dev") )) );
        { //::DistributionGaussian::clone
        
            typedef ::DistributionGaussian * ( ::DistributionGaussian::*clone_function_type)(  ) const;
            typedef ::DistributionGaussian * ( DistributionGaussian_wrapper::*default_clone_function_type)(  ) const;
            
            DistributionGaussian_exposer.def( 
                "clone"
                , clone_function_type(&::DistributionGaussian::clone)
                , default_clone_function_type(&DistributionGaussian_wrapper::default_clone)
                , bp::return_value_policy< bp::manage_new_object >() );
        
        }
        { //::DistributionGaussian::generateValueList
        
            typedef ::std::vector< double > ( ::DistributionGaussian::*generateValueList_function_type)( ::std::size_t,double,::AttLimits const & ) const;
            typedef ::std::vector< double > ( DistributionGaussian_wrapper::*default_generateValueList_function_type)( ::std::size_t,double,::AttLimits const & ) const;
            
            DistributionGaussian_exposer.def( 
                "generateValueList"
                , generateValueList_function_type(&::DistributionGaussian::generateValueList)
                , default_generateValueList_function_type(&DistributionGaussian_wrapper::default_generateValueList)
                , ( bp::arg("nbr_samples"), bp::arg("sigma_factor"), bp::arg("limits")=::AttLimits( ) ) );
        
        }
        { //::DistributionGaussian::getMean
        
            typedef double ( ::DistributionGaussian::*getMean_function_type)(  ) const;
            typedef double ( DistributionGaussian_wrapper::*default_getMean_function_type)(  ) const;
            
            DistributionGaussian_exposer.def( 
                "getMean"
                , getMean_function_type(&::DistributionGaussian::getMean)
                , default_getMean_function_type(&DistributionGaussian_wrapper::default_getMean) );
        
        }
        { //::DistributionGaussian::getStdDev
        
            typedef double ( ::DistributionGaussian::*getStdDev_function_type)(  ) const;
            
            DistributionGaussian_exposer.def( 
                "getStdDev"
                , getStdDev_function_type( &::DistributionGaussian::getStdDev )
                , "get the standard deviation." );
        
        }
        { //::DistributionGaussian::probabilityDensity
        
            typedef double ( ::DistributionGaussian::*probabilityDensity_function_type)( double ) const;
            typedef double ( DistributionGaussian_wrapper::*default_probabilityDensity_function_type)( double ) const;
            
            DistributionGaussian_exposer.def( 
                "probabilityDensity"
                , probabilityDensity_function_type(&::DistributionGaussian::probabilityDensity)
                , default_probabilityDensity_function_type(&DistributionGaussian_wrapper::default_probabilityDensity)
                , ( bp::arg("x") ) );
        
        }
        { //::IDistribution1D::generateValues
        
            typedef ::std::vector< double > ( ::IDistribution1D::*generateValues_function_type)( ::std::size_t,double,double ) const;
            typedef ::std::vector< double > ( DistributionGaussian_wrapper::*default_generateValues_function_type)( ::std::size_t,double,double ) const;
            
            DistributionGaussian_exposer.def( 
                "generateValues"
                , generateValues_function_type(&::IDistribution1D::generateValues)
                , default_generateValues_function_type(&DistributionGaussian_wrapper::default_generateValues)
                , ( bp::arg("nbr_samples"), bp::arg("xmin"), bp::arg("xmax") ) );
        
        }
    }

}
