// This file has been generated by Py++.

// ************************************************************************** //
//
//  BornAgain: simulate and fit scattering at grazing incidence
//
//! @file      Automatically generated boost::python code for BornAgain Python bindings
//! @brief     Automatically generated boost::python code for BornAgain Python bindings
//!
//! @homepage  http://bornagainproject.org
//! @license   GNU General Public License v3 or higher (see COPYING)
//! @copyright Forschungszentrum Juelich GmbH 2015
//! @authors   Scientific Computing Group at MLZ Garching
//! @authors   C. Durniak, M. Ganeva, G. Pospelov, W. Van Herck, J. Wuttke
//
// ************************************************************************** //

#include "Macros.h"
GCC_DIAG_OFF(unused-parameter)
GCC_DIAG_OFF(missing-field-initializers)
#include "boost/python.hpp"
GCC_DIAG_ON(unused-parameter)
GCC_DIAG_ON(missing-field-initializers)
#include "PythonCoreList.h"
#include "IShape2D.pypp.h"

namespace bp = boost::python;

struct IShape2D_wrapper : Geometry::IShape2D, bp::wrapper< Geometry::IShape2D > {

    IShape2D_wrapper()
    : Geometry::IShape2D()
      , bp::wrapper< Geometry::IShape2D >(){
        // null constructor
        m_pyobj = 0;
    }

    virtual ::Geometry::IShape2D * clone(  ) const {
        bp::override func_clone = this->get_override( "clone" );
        return func_clone(  );
    }

    virtual bool contains( double x, double y ) const {
        bp::override func_contains = this->get_override( "contains" );
        return func_contains( x, y );
    }

    virtual bool contains( ::Bin1D const & binx, ::Bin1D const & biny ) const {
        bp::override func_contains = this->get_override( "contains" );
        return func_contains( boost::ref(binx), boost::ref(biny) );
    }

    virtual void transferToCPP(  ) {
        
        if( !this->m_pyobj) {
            this->m_pyobj = boost::python::detail::wrapper_base_::get_owner(*this);
            Py_INCREF(this->m_pyobj);
        }
        
        if( bp::override func_transferToCPP = this->get_override( "transferToCPP" ) )
            func_transferToCPP(  );
        else{
            this->ICloneable::transferToCPP(  );
        }
    }
    
    void default_transferToCPP(  ) {
        
        if( !this->m_pyobj) {
            this->m_pyobj = boost::python::detail::wrapper_base_::get_owner(*this);
            Py_INCREF(this->m_pyobj);
        }
        
        ICloneable::transferToCPP( );
    }

    PyObject* m_pyobj;

};

void register_IShape2D_class(){

    { //::Geometry::IShape2D
        typedef bp::class_< IShape2D_wrapper, bp::bases< ICloneable >, std::auto_ptr< IShape2D_wrapper >, boost::noncopyable > IShape2D_exposer_t;
        IShape2D_exposer_t IShape2D_exposer = IShape2D_exposer_t( "IShape2D", "Basic class for all shapes in 2." );
        bp::scope IShape2D_scope( IShape2D_exposer );
        { //::Geometry::IShape2D::clone
        
            typedef ::Geometry::IShape2D * ( ::Geometry::IShape2D::*clone_function_type)(  ) const;
            
            IShape2D_exposer.def( 
                "clone"
                , bp::pure_virtual( clone_function_type(&::Geometry::IShape2D::clone) )
                , bp::return_value_policy< bp::manage_new_object >() );
        
        }
        { //::Geometry::IShape2D::contains
        
            typedef bool ( ::Geometry::IShape2D::*contains_function_type)( double,double ) const;
            
            IShape2D_exposer.def( 
                "contains"
                , bp::pure_virtual( contains_function_type(&::Geometry::IShape2D::contains) )
                , ( bp::arg("x"), bp::arg("y") )
                , "Returns true if point with given coordinates is inside or on border of the shape." );
        
        }
        { //::Geometry::IShape2D::contains
        
            typedef bool ( ::Geometry::IShape2D::*contains_function_type)( ::Bin1D const &,::Bin1D const & ) const;
            
            IShape2D_exposer.def( 
                "contains"
                , bp::pure_virtual( contains_function_type(&::Geometry::IShape2D::contains) )
                , ( bp::arg("binx"), bp::arg("biny") )
                , "Returns true if area defined by two bins is inside or on border of the shape." );
        
        }
        { //::ICloneable::transferToCPP
        
            typedef void ( ::ICloneable::*transferToCPP_function_type)(  ) ;
            typedef void ( IShape2D_wrapper::*default_transferToCPP_function_type)(  ) ;
            
            IShape2D_exposer.def( 
                "transferToCPP"
                , transferToCPP_function_type(&::ICloneable::transferToCPP)
                , default_transferToCPP_function_type(&IShape2D_wrapper::default_transferToCPP) );
        
        }
    }

}
