// This file has been generated by Py++.

// ************************************************************************** //
//
//  BornAgain: simulate and fit scattering at grazing incidence
//
//! @file      Automatically generated boost::python code for BornAgain Python bindings
//! @brief     Automatically generated boost::python code for BornAgain Python bindings
//!
//! @homepage  http://bornagainproject.org
//! @license   GNU General Public License v3 or higher (see COPYING)
//! @copyright Forschungszentrum Juelich GmbH 2015
//! @authors   Scientific Computing Group at MLZ Garching
//! @authors   C. Durniak, M. Ganeva, G. Pospelov, W. Van Herck, J. Wuttke
//
// ************************************************************************** //

#include "Macros.h"
GCC_DIAG_OFF(unused-parameter)
GCC_DIAG_OFF(missing-field-initializers)
#include "boost/python.hpp"
GCC_DIAG_ON(unused-parameter)
GCC_DIAG_ON(missing-field-initializers)
#include "PythonCoreList.h"
#include "RotationZ.pypp.h"

namespace bp = boost::python;

struct RotationZ_wrapper : RotationZ, bp::wrapper< RotationZ > {

    RotationZ_wrapper(double angle=0.0 )
    : RotationZ( angle )
      , bp::wrapper< RotationZ >(){
        // constructor
    m_pyobj = 0;
    }

    virtual ::RotationZ * clone(  ) const  {
        if( bp::override func_clone = this->get_override( "clone" ) )
            return func_clone(  );
        else{
            return this->RotationZ::clone(  );
        }
    }
    
    ::RotationZ * default_clone(  ) const  {
        return RotationZ::clone( );
    }

    virtual ::RotationZ * cloneInvertB(  ) const  {
        if( bp::override func_cloneInvertB = this->get_override( "cloneInvertB" ) )
            return func_cloneInvertB(  );
        else{
            return this->RotationZ::cloneInvertB(  );
        }
    }
    
    ::RotationZ * default_cloneInvertB(  ) const  {
        return RotationZ::cloneInvertB( );
    }

    virtual ::RotationZ * createInverse(  ) const  {
        if( bp::override func_createInverse = this->get_override( "createInverse" ) )
            return func_createInverse(  );
        else{
            return this->RotationZ::createInverse(  );
        }
    }
    
    ::RotationZ * default_createInverse(  ) const  {
        return RotationZ::createInverse( );
    }

    virtual ::Geometry::Transform3D getTransform3D(  ) const  {
        if( bp::override func_getTransform3D = this->get_override( "getTransform3D" ) )
            return func_getTransform3D(  );
        else{
            return this->RotationZ::getTransform3D(  );
        }
    }
    
    ::Geometry::Transform3D default_getTransform3D(  ) const  {
        return RotationZ::getTransform3D( );
    }

    virtual bool containsMagneticMaterial(  ) const  {
        if( bp::override func_containsMagneticMaterial = this->get_override( "containsMagneticMaterial" ) )
            return func_containsMagneticMaterial(  );
        else{
            return this->ISample::containsMagneticMaterial(  );
        }
    }
    
    bool default_containsMagneticMaterial(  ) const  {
        return ISample::containsMagneticMaterial( );
    }

    virtual ::std::vector< const ISample* > getChildren(  ) const  {
        if( bp::override func_getChildren = this->get_override( "getChildren" ) )
            return func_getChildren(  );
        else{
            return this->ISample::getChildren(  );
        }
    }
    
    ::std::vector< const ISample* > default_getChildren(  ) const  {
        return ISample::getChildren( );
    }

    virtual bool isIdentity(  ) const  {
        if( bp::override func_isIdentity = this->get_override( "isIdentity" ) )
            return func_isIdentity(  );
        else{
            return this->IRotation::isIdentity(  );
        }
    }
    
    bool default_isIdentity(  ) const  {
        return IRotation::isIdentity( );
    }

    virtual void printSampleTree(  ) {
        if( bp::override func_printSampleTree = this->get_override( "printSampleTree" ) )
            func_printSampleTree(  );
        else{
            this->ISample::printSampleTree(  );
        }
    }
    
    void default_printSampleTree(  ) {
        ISample::printSampleTree( );
    }

    virtual ::std::size_t size(  ) const  {
        if( bp::override func_size = this->get_override( "size" ) )
            return func_size(  );
        else{
            return this->ISample::size(  );
        }
    }
    
    ::std::size_t default_size(  ) const  {
        return ISample::size( );
    }

    virtual void transferToCPP(  ) {
        
        if( !this->m_pyobj) {
            this->m_pyobj = boost::python::detail::wrapper_base_::get_owner(*this);
            Py_INCREF(this->m_pyobj);
        }
        
        if( bp::override func_transferToCPP = this->get_override( "transferToCPP" ) )
            func_transferToCPP(  );
        else{
            this->ICloneable::transferToCPP(  );
        }
    }
    
    void default_transferToCPP(  ) {
        
        if( !this->m_pyobj) {
            this->m_pyobj = boost::python::detail::wrapper_base_::get_owner(*this);
            Py_INCREF(this->m_pyobj);
        }
        
        ICloneable::transferToCPP( );
    }

    PyObject* m_pyobj;

};

void register_RotationZ_class(){

    { //::RotationZ
        typedef bp::class_< RotationZ_wrapper, bp::bases< IRotation >, std::auto_ptr< RotationZ_wrapper >, boost::noncopyable > RotationZ_exposer_t;
        RotationZ_exposer_t RotationZ_exposer = RotationZ_exposer_t( "RotationZ", bp::init< bp::optional< double > >(( bp::arg("angle")=0.0 )) );
        bp::scope RotationZ_scope( RotationZ_exposer );
        { //::RotationZ::clone
        
            typedef ::RotationZ * ( ::RotationZ::*clone_function_type)(  ) const;
            typedef ::RotationZ * ( RotationZ_wrapper::*default_clone_function_type)(  ) const;
            
            RotationZ_exposer.def( 
                "clone"
                , clone_function_type(&::RotationZ::clone)
                , default_clone_function_type(&RotationZ_wrapper::default_clone)
                , bp::return_value_policy< bp::manage_new_object >() );
        
        }
        { //::RotationZ::cloneInvertB
        
            typedef ::RotationZ * ( ::RotationZ::*cloneInvertB_function_type)(  ) const;
            typedef ::RotationZ * ( RotationZ_wrapper::*default_cloneInvertB_function_type)(  ) const;
            
            RotationZ_exposer.def( 
                "cloneInvertB"
                , cloneInvertB_function_type(&::RotationZ::cloneInvertB)
                , default_cloneInvertB_function_type(&RotationZ_wrapper::default_cloneInvertB)
                , bp::return_value_policy< bp::reference_existing_object >() );
        
        }
        { //::RotationZ::createInverse
        
            typedef ::RotationZ * ( ::RotationZ::*createInverse_function_type)(  ) const;
            typedef ::RotationZ * ( RotationZ_wrapper::*default_createInverse_function_type)(  ) const;
            
            RotationZ_exposer.def( 
                "createInverse"
                , createInverse_function_type(&::RotationZ::createInverse)
                , default_createInverse_function_type(&RotationZ_wrapper::default_createInverse)
                , bp::return_value_policy< bp::manage_new_object >() );
        
        }
        { //::RotationZ::getAngle
        
            typedef double ( ::RotationZ::*getAngle_function_type)(  ) const;
            
            RotationZ_exposer.def( 
                "getAngle"
                , getAngle_function_type( &::RotationZ::getAngle ) );
        
        }
        { //::RotationZ::getTransform3D
        
            typedef ::Geometry::Transform3D ( ::RotationZ::*getTransform3D_function_type)(  ) const;
            typedef ::Geometry::Transform3D ( RotationZ_wrapper::*default_getTransform3D_function_type)(  ) const;
            
            RotationZ_exposer.def( 
                "getTransform3D"
                , getTransform3D_function_type(&::RotationZ::getTransform3D)
                , default_getTransform3D_function_type(&RotationZ_wrapper::default_getTransform3D) );
        
        }
        { //::ISample::containsMagneticMaterial
        
            typedef bool ( ::ISample::*containsMagneticMaterial_function_type)(  ) const;
            typedef bool ( RotationZ_wrapper::*default_containsMagneticMaterial_function_type)(  ) const;
            
            RotationZ_exposer.def( 
                "containsMagneticMaterial"
                , containsMagneticMaterial_function_type(&::ISample::containsMagneticMaterial)
                , default_containsMagneticMaterial_function_type(&RotationZ_wrapper::default_containsMagneticMaterial) );
        
        }
        { //::ISample::getChildren
        
            typedef ::std::vector< const ISample* > ( ::ISample::*getChildren_function_type)(  ) const;
            typedef ::std::vector< const ISample* > ( RotationZ_wrapper::*default_getChildren_function_type)(  ) const;
            
            RotationZ_exposer.def( 
                "getChildren"
                , getChildren_function_type(&::ISample::getChildren)
                , default_getChildren_function_type(&RotationZ_wrapper::default_getChildren) );
        
        }
        { //::IRotation::isIdentity
        
            typedef bool ( ::IRotation::*isIdentity_function_type)(  ) const;
            typedef bool ( RotationZ_wrapper::*default_isIdentity_function_type)(  ) const;
            
            RotationZ_exposer.def( 
                "isIdentity"
                , isIdentity_function_type(&::IRotation::isIdentity)
                , default_isIdentity_function_type(&RotationZ_wrapper::default_isIdentity) );
        
        }
        { //::ISample::printSampleTree
        
            typedef void ( ::ISample::*printSampleTree_function_type)(  ) ;
            typedef void ( RotationZ_wrapper::*default_printSampleTree_function_type)(  ) ;
            
            RotationZ_exposer.def( 
                "printSampleTree"
                , printSampleTree_function_type(&::ISample::printSampleTree)
                , default_printSampleTree_function_type(&RotationZ_wrapper::default_printSampleTree) );
        
        }
        { //::ISample::size
        
            typedef ::std::size_t ( ::ISample::*size_function_type)(  ) const;
            typedef ::std::size_t ( RotationZ_wrapper::*default_size_function_type)(  ) const;
            
            RotationZ_exposer.def( 
                "size"
                , size_function_type(&::ISample::size)
                , default_size_function_type(&RotationZ_wrapper::default_size) );
        
        }
        { //::ICloneable::transferToCPP
        
            typedef void ( ::ICloneable::*transferToCPP_function_type)(  ) ;
            typedef void ( RotationZ_wrapper::*default_transferToCPP_function_type)(  ) ;
            
            RotationZ_exposer.def( 
                "transferToCPP"
                , transferToCPP_function_type(&::ICloneable::transferToCPP)
                , default_transferToCPP_function_type(&RotationZ_wrapper::default_transferToCPP) );
        
        }
    }

}
