// This file has been generated by Py++.

// ************************************************************************** //
//
//  BornAgain: simulate and fit scattering at grazing incidence
//
//! @file      Automatically generated boost::python code for BornAgain Python bindings
//! @brief     Automatically generated boost::python code for BornAgain Python bindings
//!
//! @homepage  http://bornagainproject.org
//! @license   GNU General Public License v3 or higher (see COPYING)
//! @copyright Forschungszentrum Juelich GmbH 2015
//! @authors   Scientific Computing Group at MLZ Garching
//! @authors   C. Durniak, M. Ganeva, G. Pospelov, W. Van Herck, J. Wuttke
//
// ************************************************************************** //

#include "Macros.h"
GCC_DIAG_OFF(unused-parameter)
GCC_DIAG_OFF(missing-field-initializers)
#include "boost/python.hpp"
GCC_DIAG_ON(unused-parameter)
GCC_DIAG_ON(missing-field-initializers)
#include "PythonCoreList.h"
#include "SpecularSimulation.pypp.h"

namespace bp = boost::python;

struct SpecularSimulation_wrapper : SpecularSimulation, bp::wrapper< SpecularSimulation > {

    SpecularSimulation_wrapper( )
    : SpecularSimulation( )
      , bp::wrapper< SpecularSimulation >(){
        // null constructor
    m_pyobj = 0;
    }

    SpecularSimulation_wrapper(::ISample const & sample )
    : SpecularSimulation( boost::ref(sample) )
      , bp::wrapper< SpecularSimulation >(){
        // constructor
    m_pyobj = 0;
    }

    SpecularSimulation_wrapper(::SampleBuilder_t sample_builder )
    : SpecularSimulation( sample_builder )
      , bp::wrapper< SpecularSimulation >(){
        // constructor
    m_pyobj = 0;
    }

    virtual ::SpecularSimulation * clone(  ) const  {
        if( bp::override func_clone = this->get_override( "clone" ) )
            return func_clone(  );
        else{
            return this->SpecularSimulation::clone(  );
        }
    }
    
    ::SpecularSimulation * default_clone(  ) const  {
        return SpecularSimulation::clone( );
    }

    virtual void transferToCPP(  ) {
        
        if( !this->m_pyobj) {
            this->m_pyobj = boost::python::detail::wrapper_base_::get_owner(*this);
            Py_INCREF(this->m_pyobj);
        }
        
        if( bp::override func_transferToCPP = this->get_override( "transferToCPP" ) )
            func_transferToCPP(  );
        else{
            this->ICloneable::transferToCPP(  );
        }
    }
    
    void default_transferToCPP(  ) {
        
        if( !this->m_pyobj) {
            this->m_pyobj = boost::python::detail::wrapper_base_::get_owner(*this);
            Py_INCREF(this->m_pyobj);
        }
        
        ICloneable::transferToCPP( );
    }

    PyObject* m_pyobj;

};

void register_SpecularSimulation_class(){

    { //::SpecularSimulation
        typedef bp::class_< SpecularSimulation_wrapper, bp::bases< ICloneable, IParameterized >, std::auto_ptr< SpecularSimulation_wrapper >, boost::noncopyable > SpecularSimulation_exposer_t;
        SpecularSimulation_exposer_t SpecularSimulation_exposer = SpecularSimulation_exposer_t( "SpecularSimulation", "Main class to run a specular simulation.", bp::init< >() );
        bp::scope SpecularSimulation_scope( SpecularSimulation_exposer );
        SpecularSimulation_exposer.def( bp::init< ISample const & >(( bp::arg("sample") )) );
        SpecularSimulation_exposer.def( bp::init< SampleBuilder_t >(( bp::arg("sample_builder") )) );
        { //::SpecularSimulation::clone
        
            typedef ::SpecularSimulation * ( ::SpecularSimulation::*clone_function_type)(  ) const;
            typedef ::SpecularSimulation * ( SpecularSimulation_wrapper::*default_clone_function_type)(  ) const;
            
            SpecularSimulation_exposer.def( 
                "clone"
                , clone_function_type(&::SpecularSimulation::clone)
                , default_clone_function_type(&SpecularSimulation_wrapper::default_clone)
                , bp::return_value_policy< bp::manage_new_object >() );
        
        }
        { //::SpecularSimulation::getAlphaAxis
        
            typedef ::IAxis const * ( ::SpecularSimulation::*getAlphaAxis_function_type)(  ) const;
            
            SpecularSimulation_exposer.def( 
                "getAlphaAxis"
                , getAlphaAxis_function_type( &::SpecularSimulation::getAlphaAxis )
                , bp::return_value_policy< bp::reference_existing_object >()
                , "returns alpha_i axis." );
        
        }
        { //::SpecularSimulation::getLayerRTCoefficients
        
            typedef ::boost::shared_ptr< const ILayerRTCoefficients > ( ::SpecularSimulation::*getLayerRTCoefficients_function_type)( ::std::size_t,::std::size_t ) const;
            
            SpecularSimulation_exposer.def( 
                "getLayerRTCoefficients"
                , getLayerRTCoefficients_function_type( &::SpecularSimulation::getLayerRTCoefficients )
                , ( bp::arg("i_alpha"), bp::arg("i_layer") )
                , "returns vector containing Kz coefficients for all alpha_i angles for given layer index." );
        
        }
        { //::SpecularSimulation::getSample
        
            typedef ::ISample * ( ::SpecularSimulation::*getSample_function_type)(  ) const;
            
            SpecularSimulation_exposer.def( 
                "getSample"
                , getSample_function_type( &::SpecularSimulation::getSample )
                , bp::return_value_policy< bp::reference_existing_object >()
                , "Returns the sample." );
        
        }
        { //::SpecularSimulation::getSampleBuilder
        
            typedef ::SampleBuilder_t ( ::SpecularSimulation::*getSampleBuilder_function_type)(  ) const;
            
            SpecularSimulation_exposer.def( 
                "getSampleBuilder"
                , getSampleBuilder_function_type( &::SpecularSimulation::getSampleBuilder )
                , "return sample builder." );
        
        }
        { //::SpecularSimulation::getScalarKz
        
            typedef ::std::vector< std::complex<double> > ( ::SpecularSimulation::*getScalarKz_function_type)( ::std::size_t ) const;
            
            SpecularSimulation_exposer.def( 
                "getScalarKz"
                , getScalarKz_function_type( &::SpecularSimulation::getScalarKz )
                , ( bp::arg("i_layer") )
                , "returns vector containing Kz coefficients for all alpha_i angles for given layer index." );
        
        }
        { //::SpecularSimulation::getScalarR
        
            typedef ::std::vector< std::complex<double> > ( ::SpecularSimulation::*getScalarR_function_type)( ::std::size_t ) const;
            
            SpecularSimulation_exposer.def( 
                "getScalarR"
                , getScalarR_function_type( &::SpecularSimulation::getScalarR )
                , ( bp::arg("i_layer") )
                , "returns vector containing reflection coefficients for all alpha_i angles for given layer index." );
        
        }
        { //::SpecularSimulation::getScalarT
        
            typedef ::std::vector< std::complex<double> > ( ::SpecularSimulation::*getScalarT_function_type)( ::std::size_t ) const;
            
            SpecularSimulation_exposer.def( 
                "getScalarT"
                , getScalarT_function_type( &::SpecularSimulation::getScalarT )
                , ( bp::arg("i_layer") )
                , "returns vector containing transmission coefficients for all alpha_i angles for given layer index." );
        
        }
        { //::SpecularSimulation::prepareSimulation
        
            typedef void ( ::SpecularSimulation::*prepareSimulation_function_type)(  ) ;
            
            SpecularSimulation_exposer.def( 
                "prepareSimulation"
                , prepareSimulation_function_type( &::SpecularSimulation::prepareSimulation )
                , "Put into a clean state for running a simulation." );
        
        }
        { //::SpecularSimulation::runSimulation
        
            typedef void ( ::SpecularSimulation::*runSimulation_function_type)(  ) ;
            
            SpecularSimulation_exposer.def( 
                "runSimulation"
                , runSimulation_function_type( &::SpecularSimulation::runSimulation )
                , "Run a simulation with the current parameter settings." );
        
        }
        { //::SpecularSimulation::setBeamParameters
        
            typedef void ( ::SpecularSimulation::*setBeamParameters_function_type)( double,::IAxis const & ) ;
            
            SpecularSimulation_exposer.def( 
                "setBeamParameters"
                , setBeamParameters_function_type( &::SpecularSimulation::setBeamParameters )
                , ( bp::arg("lambda"), bp::arg("alpha_axis") )
                , "Sets beam parameters with alpha_i of the beam defined in the range." );
        
        }
        { //::SpecularSimulation::setBeamParameters
        
            typedef void ( ::SpecularSimulation::*setBeamParameters_function_type)( double,int,double,double ) ;
            
            SpecularSimulation_exposer.def( 
                "setBeamParameters"
                , setBeamParameters_function_type( &::SpecularSimulation::setBeamParameters )
                , ( bp::arg("lambda"), bp::arg("nbins"), bp::arg("alpha_i_min"), bp::arg("alpha_i_max") )
                , "Sets beam parameters with alpha_i of the beam defined in the range." );
        
        }
        { //::SpecularSimulation::setEvanescentWaveAxis
        
            typedef void ( ::SpecularSimulation::*setEvanescentWaveAxis_function_type)( ::IAxis const & ) ;
            
            SpecularSimulation_exposer.def( 
                "setEvanescentWaveAxis"
                , setEvanescentWaveAxis_function_type( &::SpecularSimulation::setEvanescentWaveAxis )
                , ( bp::arg("z_axis") )
                , "set axis for evanescent wave axis." );
        
        }
        { //::SpecularSimulation::setEvanescentWaveAxis
        
            typedef void ( ::SpecularSimulation::*setEvanescentWaveAxis_function_type)( int,double,double ) ;
            
            SpecularSimulation_exposer.def( 
                "setEvanescentWaveAxis"
                , setEvanescentWaveAxis_function_type( &::SpecularSimulation::setEvanescentWaveAxis )
                , ( bp::arg("nbins"), bp::arg("z_min"), bp::arg("z_max") )
                , "set axis for evanescent wave axis." );
        
        }
        { //::SpecularSimulation::setSample
        
            typedef void ( ::SpecularSimulation::*setSample_function_type)( ::ISample const & ) ;
            
            SpecularSimulation_exposer.def( 
                "setSample"
                , setSample_function_type( &::SpecularSimulation::setSample )
                , ( bp::arg("sample") )
                , "Sets the sample to be tested." );
        
        }
        { //::SpecularSimulation::setSampleBuilder
        
            typedef void ( ::SpecularSimulation::*setSampleBuilder_function_type)( ::SampleBuilder_t ) ;
            
            SpecularSimulation_exposer.def( 
                "setSampleBuilder"
                , setSampleBuilder_function_type( &::SpecularSimulation::setSampleBuilder )
                , ( bp::arg("sample_builder") )
                , "Sets the sample builder." );
        
        }
        { //::ICloneable::transferToCPP
        
            typedef void ( ::ICloneable::*transferToCPP_function_type)(  ) ;
            typedef void ( SpecularSimulation_wrapper::*default_transferToCPP_function_type)(  ) ;
            
            SpecularSimulation_exposer.def( 
                "transferToCPP"
                , transferToCPP_function_type(&::ICloneable::transferToCPP)
                , default_transferToCPP_function_type(&SpecularSimulation_wrapper::default_transferToCPP) );
        
        }
    }

}
