// This file has been generated by Py++.

// ************************************************************************** //
//
//  BornAgain: simulate and fit scattering at grazing incidence
//
//! @file      Automatically generated boost::python code for BornAgain Python bindings
//! @brief     Automatically generated boost::python code for BornAgain Python bindings
//!
//! @homepage  http://bornagainproject.org
//! @license   GNU General Public License v3 or higher (see COPYING)
//! @copyright Forschungszentrum Juelich GmbH 2015
//! @authors   Scientific Computing Group at MLZ Garching
//! @authors   C. Durniak, M. Ganeva, G. Pospelov, W. Van Herck, J. Wuttke
//
// ************************************************************************** //

#include "Macros.h"
GCC_DIAG_OFF(unused-parameter)
GCC_DIAG_OFF(missing-field-initializers)
#include "boost/python.hpp"
GCC_DIAG_ON(unused-parameter)
GCC_DIAG_ON(missing-field-initializers)
#include "PythonFitList.h"
#include "IntensityScaleAndShiftNormalizer.pypp.h"

namespace bp = boost::python;

struct IntensityScaleAndShiftNormalizer_wrapper : IntensityScaleAndShiftNormalizer, bp::wrapper< IntensityScaleAndShiftNormalizer > {

    IntensityScaleAndShiftNormalizer_wrapper(IntensityScaleAndShiftNormalizer const & arg )
    : IntensityScaleAndShiftNormalizer( arg )
      , bp::wrapper< IntensityScaleAndShiftNormalizer >(){
        // copy constructor
        m_pyobj = 0;
    }

    IntensityScaleAndShiftNormalizer_wrapper(double scale=1.0e+0, double shift=0.0 )
    : IntensityScaleAndShiftNormalizer( scale, shift )
      , bp::wrapper< IntensityScaleAndShiftNormalizer >(){
        // constructor
    m_pyobj = 0;
    }

    virtual ::IntensityScaleAndShiftNormalizer * clone(  ) const  {
        if( bp::override func_clone = this->get_override( "clone" ) )
            return func_clone(  );
        else{
            return this->IntensityScaleAndShiftNormalizer::clone(  );
        }
    }
    
    ::IntensityScaleAndShiftNormalizer * default_clone(  ) const  {
        return IntensityScaleAndShiftNormalizer::clone( );
    }

    virtual void setMaximumIntensity( double max_intensity ) {
        if( bp::override func_setMaximumIntensity = this->get_override( "setMaximumIntensity" ) )
            func_setMaximumIntensity( max_intensity );
        else{
            this->IntensityScaleAndShiftNormalizer::setMaximumIntensity( max_intensity );
        }
    }
    
    void default_setMaximumIntensity( double max_intensity ) {
        IntensityScaleAndShiftNormalizer::setMaximumIntensity( max_intensity );
    }

    virtual void apply( ::OutputData< double > & data ) const  {
        if( bp::override func_apply = this->get_override( "apply" ) )
            func_apply( boost::ref(data) );
        else{
            this->IntensityNormalizer::apply( boost::ref(data) );
        }
    }
    
    void default_apply( ::OutputData< double > & data ) const  {
        IntensityNormalizer::apply( boost::ref(data) );
    }

    virtual ::OutputData< double > * createNormalizedData( ::OutputData< double > const & data ) const  {
        if( bp::override func_createNormalizedData = this->get_override( "createNormalizedData" ) )
            return func_createNormalizedData( boost::ref(data) );
        else{
            return this->IntensityNormalizer::createNormalizedData( boost::ref(data) );
        }
    }
    
    ::OutputData< double > * default_createNormalizedData( ::OutputData< double > const & data ) const  {
        return IntensityNormalizer::createNormalizedData( boost::ref(data) );
    }

    PyObject* m_pyobj;

};

void register_IntensityScaleAndShiftNormalizer_class(){

    { //::IntensityScaleAndShiftNormalizer
        typedef bp::class_< IntensityScaleAndShiftNormalizer_wrapper, bp::bases< IntensityNormalizer >, std::auto_ptr< IntensityScaleAndShiftNormalizer_wrapper > > IntensityScaleAndShiftNormalizer_exposer_t;
        IntensityScaleAndShiftNormalizer_exposer_t IntensityScaleAndShiftNormalizer_exposer = IntensityScaleAndShiftNormalizer_exposer_t( "IntensityScaleAndShiftNormalizer", "Simplified OutputData normalizer, with max_intensity=1.", bp::init< bp::optional< double, double > >(( bp::arg("scale")=1.0e+0, bp::arg("shift")=0.0 )) );
        bp::scope IntensityScaleAndShiftNormalizer_scope( IntensityScaleAndShiftNormalizer_exposer );
        { //::IntensityScaleAndShiftNormalizer::clone
        
            typedef ::IntensityScaleAndShiftNormalizer * ( ::IntensityScaleAndShiftNormalizer::*clone_function_type)(  ) const;
            typedef ::IntensityScaleAndShiftNormalizer * ( IntensityScaleAndShiftNormalizer_wrapper::*default_clone_function_type)(  ) const;
            
            IntensityScaleAndShiftNormalizer_exposer.def( 
                "clone"
                , clone_function_type(&::IntensityScaleAndShiftNormalizer::clone)
                , default_clone_function_type(&IntensityScaleAndShiftNormalizer_wrapper::default_clone)
                , bp::return_value_policy< bp::manage_new_object >() );
        
        }
        { //::IntensityScaleAndShiftNormalizer::setMaximumIntensity
        
            typedef void ( ::IntensityScaleAndShiftNormalizer::*setMaximumIntensity_function_type)( double ) ;
            typedef void ( IntensityScaleAndShiftNormalizer_wrapper::*default_setMaximumIntensity_function_type)( double ) ;
            
            IntensityScaleAndShiftNormalizer_exposer.def( 
                "setMaximumIntensity"
                , setMaximumIntensity_function_type(&::IntensityScaleAndShiftNormalizer::setMaximumIntensity)
                , default_setMaximumIntensity_function_type(&IntensityScaleAndShiftNormalizer_wrapper::default_setMaximumIntensity)
                , ( bp::arg("max_intensity") ) );
        
        }
        { //::IntensityNormalizer::apply
        
            typedef void ( ::IntensityNormalizer::*apply_function_type)( ::OutputData< double > & ) const;
            typedef void ( IntensityScaleAndShiftNormalizer_wrapper::*default_apply_function_type)( ::OutputData< double > & ) const;
            
            IntensityScaleAndShiftNormalizer_exposer.def( 
                "apply"
                , apply_function_type(&::IntensityNormalizer::apply)
                , default_apply_function_type(&IntensityScaleAndShiftNormalizer_wrapper::default_apply)
                , ( bp::arg("data") ) );
        
        }
        { //::IntensityNormalizer::createNormalizedData
        
            typedef ::OutputData< double > * ( ::IntensityNormalizer::*createNormalizedData_function_type)( ::OutputData< double > const & ) const;
            typedef ::OutputData< double > * ( IntensityScaleAndShiftNormalizer_wrapper::*default_createNormalizedData_function_type)( ::OutputData< double > const & ) const;
            
            IntensityScaleAndShiftNormalizer_exposer.def( 
                "createNormalizedData"
                , createNormalizedData_function_type(&::IntensityNormalizer::createNormalizedData)
                , default_createNormalizedData_function_type(&IntensityScaleAndShiftNormalizer_wrapper::default_createNormalizedData)
                , ( bp::arg("data") )
                , bp::return_value_policy< bp::manage_new_object >() );
        
        }
    }

}
