// This file has been generated by Py++.

// ************************************************************************** //
//
//  BornAgain: simulate and fit scattering at grazing incidence
//
//! @file      Automatically generated boost::python code for BornAgain Python bindings
//! @brief     Automatically generated boost::python code for BornAgain Python bindings
//!
//! @homepage  http://bornagainproject.org
//! @license   GNU General Public License v3 or higher (see COPYING)
//! @copyright Forschungszentrum Juelich GmbH 2015
//! @authors   Scientific Computing Group at MLZ Garching
//! @authors   C. Durniak, M. Ganeva, G. Pospelov, W. Van Herck, J. Wuttke
//
// ************************************************************************** //

#include "Macros.h"
GCC_DIAG_OFF(unused-parameter)
GCC_DIAG_OFF(missing-field-initializers)
#include "boost/python.hpp"
GCC_DIAG_ON(unused-parameter)
GCC_DIAG_ON(missing-field-initializers)
#include "PythonFitList.h"
#include "SquaredFunctionSystematicError.pypp.h"

namespace bp = boost::python;

struct SquaredFunctionSystematicError_wrapper : SquaredFunctionSystematicError, bp::wrapper< SquaredFunctionSystematicError > {

    SquaredFunctionSystematicError_wrapper(double epsilon=8.000000000000000166533453693773481063544750213623046875e-2 )
    : SquaredFunctionSystematicError( epsilon )
      , bp::wrapper< SquaredFunctionSystematicError >(){
        // constructor
    m_pyobj = 0;
    }

    virtual double calculateSquaredDifference( double real_value, double simulated_value ) const  {
        if( bp::override func_calculateSquaredDifference = this->get_override( "calculateSquaredDifference" ) )
            return func_calculateSquaredDifference( real_value, simulated_value );
        else{
            return this->SquaredFunctionSystematicError::calculateSquaredDifference( real_value, simulated_value );
        }
    }
    
    double default_calculateSquaredDifference( double real_value, double simulated_value ) const  {
        return SquaredFunctionSystematicError::calculateSquaredDifference( real_value, simulated_value );
    }

    virtual double calculateSquaredError( double real_value, double simulated_value ) const  {
        if( bp::override func_calculateSquaredError = this->get_override( "calculateSquaredError" ) )
            return func_calculateSquaredError( real_value, simulated_value );
        else{
            return this->SquaredFunctionSystematicError::calculateSquaredError( real_value, simulated_value );
        }
    }
    
    double default_calculateSquaredError( double real_value, double simulated_value ) const  {
        return SquaredFunctionSystematicError::calculateSquaredError( real_value, simulated_value );
    }

    virtual ::SquaredFunctionSystematicError * clone(  ) const  {
        if( bp::override func_clone = this->get_override( "clone" ) )
            return func_clone(  );
        else{
            return this->SquaredFunctionSystematicError::clone(  );
        }
    }
    
    ::SquaredFunctionSystematicError * default_clone(  ) const  {
        return SquaredFunctionSystematicError::clone( );
    }

    PyObject* m_pyobj;

};

void register_SquaredFunctionSystematicError_class(){

    { //::SquaredFunctionSystematicError
        typedef bp::class_< SquaredFunctionSystematicError_wrapper, bp::bases< ISquaredFunction >, std::auto_ptr< SquaredFunctionSystematicError_wrapper >, boost::noncopyable > SquaredFunctionSystematicError_exposer_t;
        SquaredFunctionSystematicError_exposer_t SquaredFunctionSystematicError_exposer = SquaredFunctionSystematicError_exposer_t( "SquaredFunctionSystematicError", "Squared difference between two values normalized by systematic error value = (a-b)*(a-b)/norm, where norm = max(error, 1.", bp::init< bp::optional< double > >(( bp::arg("epsilon")=8.000000000000000166533453693773481063544750213623046875e-2 )) );
        bp::scope SquaredFunctionSystematicError_scope( SquaredFunctionSystematicError_exposer );
        { //::SquaredFunctionSystematicError::calculateSquaredDifference
        
            typedef double ( ::SquaredFunctionSystematicError::*calculateSquaredDifference_function_type)( double,double ) const;
            typedef double ( SquaredFunctionSystematicError_wrapper::*default_calculateSquaredDifference_function_type)( double,double ) const;
            
            SquaredFunctionSystematicError_exposer.def( 
                "calculateSquaredDifference"
                , calculateSquaredDifference_function_type(&::SquaredFunctionSystematicError::calculateSquaredDifference)
                , default_calculateSquaredDifference_function_type(&SquaredFunctionSystematicError_wrapper::default_calculateSquaredDifference)
                , ( bp::arg("real_value"), bp::arg("simulated_value") ) );
        
        }
        { //::SquaredFunctionSystematicError::calculateSquaredError
        
            typedef double ( ::SquaredFunctionSystematicError::*calculateSquaredError_function_type)( double,double ) const;
            typedef double ( SquaredFunctionSystematicError_wrapper::*default_calculateSquaredError_function_type)( double,double ) const;
            
            SquaredFunctionSystematicError_exposer.def( 
                "calculateSquaredError"
                , calculateSquaredError_function_type(&::SquaredFunctionSystematicError::calculateSquaredError)
                , default_calculateSquaredError_function_type(&SquaredFunctionSystematicError_wrapper::default_calculateSquaredError)
                , ( bp::arg("real_value"), bp::arg("simulated_value") ) );
        
        }
        { //::SquaredFunctionSystematicError::clone
        
            typedef ::SquaredFunctionSystematicError * ( ::SquaredFunctionSystematicError::*clone_function_type)(  ) const;
            typedef ::SquaredFunctionSystematicError * ( SquaredFunctionSystematicError_wrapper::*default_clone_function_type)(  ) const;
            
            SquaredFunctionSystematicError_exposer.def( 
                "clone"
                , clone_function_type(&::SquaredFunctionSystematicError::clone)
                , default_clone_function_type(&SquaredFunctionSystematicError_wrapper::default_clone)
                , bp::return_value_policy< bp::manage_new_object >() );
        
        }
    }

}
